function [ AA,ohraniceni ] = upravy_obrazu ( A,obr ) 
[x,y]=size(A);

%% podle clanku 11
A=imfill(A,'holes');
A(round(14*x/15):x,:)=0;

%odstraneni malych oblasti - počet pixelu bilych oblasti
CC = bwconncomp(A);
numPixels = cellfun(@numel,CC.PixelIdxList);
for i=1:length(numPixels)
     if numPixels(i)<1500 
         A(CC.PixelIdxList{i}) = 0;
     end
end

%eroze
SE=strel('disk',4,4);
A=imerode(A,SE, 'same');
%figure; imshow(A); title('eroze');
CC = bwconncomp(A); %odstraneni malych oblasti
numPixels = cellfun(@numel,CC.PixelIdxList);
for i=1:length(numPixels)
     if numPixels(i)<1500
         A(CC.PixelIdxList{i}) = 0;
     end
end
%dilatace
SE=strel('disk',3,6);
A=imdilate(A, SE, 'same');
%figure; imshow(A); title('dilatace');

%ocislovani obliceju
L = bwlabel(A); % ocislovani bilych oblasti
ss = regionprops(L, 'Centroid');

%box ratio
L=int8(L);
smazat1=0;
vlastnosti=regionprops(L, 'BoundingBox');
for a=1:max(max(L))     
     ohraniceni=vlastnosti(a).BoundingBox;
     boxratio(a)=ohraniceni(4) / ohraniceni(3);
    if boxratio(a)<0.6 || boxratio(a)>2.1
        smazat1=[smazat1, a];
    end
end

%eccentricity
smazat2=0;
for a=1:max(max(L))
    vlastnosti = regionprops( A(L==a), 'Eccentricity');
    if ((vlastnosti.Eccentricity<0.25) || (vlastnosti.Eccentricity>1.0))
            smazat2=[smazat2, a];
    end   
end

%ostraneni oblasti se spatnym ratio poměrem a spatnou ekcentricnosti
smazat1=smazat1(2:length(smazat1));
smazat2=smazat2(2:length(smazat2));
smazat=[smazat1, smazat2];
for b=1:length(smazat) 
    for i=1:x 
        for j=1:y 
            if L(i,j)==smazat(b) 
                A(i,j)=0;
            end            
        end
    end
end

L = bwlabel(A);
vlastnosti2 = regionprops(L, 'Centroid', 'BoundingBox');
for a=1:max(max(L))
    ohraniceni(a,:)=vlastnosti2(a).BoundingBox;
    x1=ohraniceni(a,1);
    y1=ohraniceni(a,2);
    x2=x1+ohraniceni(a,3);
    y2=y1+ohraniceni(a,4);
    vrcholyX=[x1, x2, x2, x1, x1];
    vrcholyY=[y1, y1, y2, y2, y1];
end

AA=A;